/*
 * Created on Nov 2, 2004
 *
 */
package edu.toronto.xpath.xpathTraversingTree;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.xml.namespace.QName;
import javax.xml.xpath.XPathConstants;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


import edu.toronto.xpath.evaluation.XPathResult;
import edu.toronto.xpath.util.XTTHelper;

/*
THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

1. DEFINITIONS

"Contribution" means:

a) in the case of the initial Contributor, the initial code and documentation distributed under this Agreement, and
b) in the case of each subsequent Contributor:

i) changes to the Program, and

ii) additions to the Program;

where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.

"Contributor" means any person or entity that distributes the Program.

"Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the Program.

"Program" means the Contributions distributed in accordance with this Agreement.

"Recipient" means anyone who receives the Program under this Agreement, including all Contributors.

2. GRANT OF RIGHTS

a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code and object code form.

b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per se is licensed hereunder.

c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.

d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this Agreement.

3. REQUIREMENTS

A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that:

a) it complies with the terms and conditions of this Agreement; and

b) its license agreement:

i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement, and implied warranties or conditions of merchantability and fitness for a particular purpose;

ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost profits;

iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and

iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium customarily used for software exchange.

When the Program is made available in source code form:

a) it must be made available under this Agreement; and

b) a copy of this Agreement must be included with each copy of the Program.

Contributors may not remove or alter any copyright notices contained within the Program.

Each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator of the Contribution.

4. COMMERCIAL DISTRIBUTION

Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in any such claim at its own expense.

For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages.

5. NO WARRANTY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the Program and assumes all risks associated with its exercise of rights under this Agreement , including but not limited to the risks and costs of program errors, compliance with applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations.

6. DISCLAIMER OF LIABILITY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

7. GENERAL

If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable.

If Recipient institutes patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed.

All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the Program shall continue and survive.

Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid inconsistency the Agreement is copyrighted and may only be modified in the following manner. The Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement from time to time. No one other than the Agreement Steward has the right to modify this Agreement. The Eclipse Foundation is the initial Agreement Steward. The Eclipse Foundation may assign the responsibility to serve as the Agreement Steward to a suitable separate entity. Each new version of the Agreement will be given a distinguishing version number. The Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved.

This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation.

 */

/**
 * A FULLDXPathExpression is a full xpath expression that including the
 * operators For example: /a/b/c | //c is a full xpath expression and /a/b/c is
 * a xpath expression only.
 * 
 * @author John (Wen Sheng) Liu, University of Toronto, john_ws_liu@yahoo.com
 *  
 */
public class FullExpressionXTT_Node extends XTT_Node {

	//predefined operation types
	public static int NO_OPERATION_TYPE = 0;

	public static int OP_ADD = 1;

	public static int OP_AND = 2;

	public static int OP_DIVIDE = 3;

	public static int OP_EQUAL = 4;

	public static int OP_NOT_EQUAL = 5;

	public static int OP_GREATER_THAN = 6;

	public static int OP_GREATER_THAN_EQUAL = 7;

	public static int OP_LESS_TAHN = 8;

	public static int OP_LESS_TAHN_EQUAL = 9;

	public static int OP_MOD = 10;

	public static int OP_MULTIPLY = 11;

	public static int OP_NEGATE = 12;

	public static int OP_OR = 13;

	public static int OP_SUBTRACT = 14;

	public static int OP_UNION = 15;

	//precedence of this operations
	public static int PRE_ADD = 4;

	public static int PRE_AND = 1;

	public static int PRE_DIVIDE = 5;

	public static int PRE_EQUAL = 2;

	public static int PRE_NOT_EQUAL = 2;

	public static int PRE_GREATER_THAN = 3;

	public static int PRE_GREATER_THAN_EQUAL = 3;

	public static int PRE_LESS_TAHN = 3;

	public static int PRE_LESS_TAHN_EQUAL = 3;

	public static int PRE_MOD = 5;

	public static int PRE_MULTIPLY = 5;

	public static int PRE_NEGATE = 6;

	public static int PRE_OR = 0;

	public static int PRE_SUBTRACT = 4;

	public static int PRE_UNION = 7;

	//if this operation is symmetric
	public static boolean SYM_ADD = true;

	public static boolean SYM_AND = true;

	public static boolean SYM_DIVIDE = false;

	public static boolean SYM_EQUAL = true;

	public static boolean SYN_NOT_EQUAl = true;

	public static boolean SYM_GREATER_THAN = false;

	public static boolean SYM_GREATER_THAN_EQUAL = false;

	public static boolean SYM_LESS_TAHN = false;

	public static boolean SYM_LESS_TAHN_EQUAL = false;

	public static boolean SYM_MOD = false;

	public static boolean SYM_MULTIPLY = true;

	public static boolean SYM_NEGATE = false;

	public static boolean SYM_OR = true;

	public static boolean SYM_SUBTRACT = false;

	public static boolean SYM_UNION = true;
	
//	a list of XPath expressions.
	private List expressions;

	private XTT_Token operator;

	//The xpath result.
	//private Result XPathResult;

	private StepXTT_Node lastStepForDebug = null;

	//the operationType is 0 means it is not an operation.
	private int operationType = NO_OPERATION_TYPE;

	//if this is a operation, the following fields are necessary.

	private int precedence;

	private boolean symmetric;
	
	private XPathResult xpathResult;
	
	private int exprNum;
	
	public static int exprSeriesNum = 1;
	

	/**
	 * @param parent
	 * @param contextPath
	 */
	public FullExpressionXTT_Node(XTT_Node parent, String contextPath) {
		super(parent, contextPath);
		expressions = new ArrayList();
		this.exprNum = exprSeriesNum;
		exprSeriesNum++;
	}

	/**
	 * @return Returns the operator.
	 */
	public XTT_Token getOperator() {
		return operator;
	}

	/**
	 * @param operator
	 *            The operator to set.
	 */
	public void setOperator(XTT_Token operator) {
		this.operator = operator;
	}

	
	/**
	 * @return Returns the exprNum.
	 */
	public int getExprNum() {
		return exprNum;
	}
	/**
	 * @return Returns the expressions.
	 */
	public List getExpressions() {
		return expressions;
	}
	
	
	/**
	 * @return Returns the xpathResult.
	 */
	public XPathResult getXPathResult() {
		return xpathResult;
	}
	/**
	 * @param xpathResult The xpathResult to set.
	 */
	public void setXPathResult(XPathResult xpathResult) {
		this.xpathResult = xpathResult;
	}
	/**
	 * @return Returns the expressions.
	 */
	public void addExpr(Object newExprOrOperator) {
		expressions.add(newExprOrOperator);
	}

	/**
	 * @return Returns the lastStepForDebug.
	 */
	public StepXTT_Node getLastStepForDebug() {
		return lastStepForDebug;
	}

	/**
	 * @param lastStepForDebug
	 *            The lastStepForDebug to set.
	 */
	public void setLastStepForDebug(StepXTT_Node lastStepForDebug) {
		this.lastStepForDebug = lastStepForDebug;
	}

	/** **************************************************************************************************** */
	public String getXPathString() {
		Iterator iterator = this.expressions.iterator();
		String result = "";
		if (!isOperation()) {
			if (iterator.hasNext()) {
				result = ((XTT_Node) iterator.next()).getXPathString();
			}
		} else {
			if (this.expressions.size() == 1) {
				result = getOperator().toString()
						+ parenthesize((FullExpressionXTT_Node) expressions
								.get(0), false);
			} else {
				StringBuffer buffer = new StringBuffer();
				for (int i = 0; i < expressions.size(); i++) {
					if (i > 0) {
						buffer.append(' ');
						buffer.append(getOperator().toString());
						buffer.append(' ');
					}
					buffer
							.append(parenthesize(
									(FullExpressionXTT_Node) expressions.get(i),
									i == 0));
				}
				result = buffer.toString();
			}
		}
		return result;

	}

	private String parenthesize(FullExpressionXTT_Node fullExpr, boolean left) {
		if (!fullExpr.isOperation()) {
			return fullExpr.getXPathString();
		}

		int myPrecedence = this.getPrecedence();
		int thePrecedence = fullExpr.getPrecedence();

		boolean needParens = true;
		if (myPrecedence < thePrecedence) {
			needParens = false;
		} else if (myPrecedence == thePrecedence) {
			if (isSymmetric()) {
				needParens = false;
			} else {
				needParens = !left;
			}
		}

		if (needParens) {
			return "(" + fullExpr.getXPathString() + ")";
		} else {
			return fullExpr.getXPathString();
		}
	}
	
	public String getDebugXPathString(StepXTT_Node lastStep) {
		ExpressionXTT_Node targetExpr = getExpression(lastStep);
		Iterator iterator = this.expressions.iterator();
		String result = "";
		if (!isOperation()) {
			if (iterator.hasNext()) {
				XTT_Node thisNode = (XTT_Node) iterator.next();
				//find the target expression
				if (thisNode.getMySequenceNum() == targetExpr
						.getMySequenceNum()) {
					int lastStepNum = lastStep.getStepNum();
					result = ((ExpressionXTT_Node) thisNode)
							.getDebugXPathString(lastStepNum);
				} else {
					result = thisNode.getXPathString();
				}
			}
		} else {
			if (this.expressions.size() == 1) {
				result = getOperator().toString()
						+ parenthesize(
								(FullExpressionXTT_Node) expressions.get(0),
								false, lastStep);
			} else {
				StringBuffer buffer = new StringBuffer();
				for (int i = 0; i < expressions.size(); i++) {
					if (i > 0) {
						buffer.append(' ');
						buffer.append(getOperator().toString());
						buffer.append(' ');
					}
					buffer.append(parenthesize(
							(FullExpressionXTT_Node) expressions.get(i),
							i == 0, lastStep));
				}
				result = buffer.toString();
			}
		}
		return result;

	}
	
	public String getDebugOriginalXPath(){
		if(this.lastStepForDebug != null){
			return this.getDebugXPathString(this.lastStepForDebug);
		}else
			return this.getXPathString();
	}
	
	private String parenthesize(FullExpressionXTT_Node fullExpr,
			boolean left, StepXTT_Node lastStep) {
		if (!fullExpr.isOperation()) {
			return fullExpr.getDebugXPathString(lastStep);
		}

		int myPrecedence = this.getPrecedence();
		int thePrecedence = fullExpr.getPrecedence();

		boolean needParens = true;
		if (myPrecedence < thePrecedence) {
			needParens = false;
		} else if (myPrecedence == thePrecedence) {
			if (isSymmetric()) {
				needParens = false;
			} else {
				needParens = !left;
			}
		}

		if (needParens) {
			return "(" + fullExpr.getDebugXPathString(lastStep) + ")";
		} else {
			return fullExpr.getDebugXPathString(lastStep);
		}
	}

	/** ************************************************************************************************* */
	public String getEvaluateXPathString() {
		Iterator iterator = this.expressions.iterator();
		String result = "";
		if (!isOperation()) {
			if (iterator.hasNext()) {
				result = ((XTT_Node) iterator.next()).getEvaluateXPathString();
			}
		} else {
			if (this.expressions.size() == 1) {
				result = getOperator().toString()
						+ parenthesizeEvalStr(
								(FullExpressionXTT_Node) expressions.get(0),
								false);
			} else {
				StringBuffer buffer = new StringBuffer();
				for (int i = 0; i < expressions.size(); i++) {
					if (i > 0) {
						buffer.append(' ');
						buffer.append(getOperator().toString());
						buffer.append(' ');
					}
					buffer
							.append(parenthesizeEvalStr(
									(FullExpressionXTT_Node) expressions.get(i),
									i == 0));
				}
				result = buffer.toString();
			}
		}
		return result;

	}

	private String parenthesizeEvalStr(FullExpressionXTT_Node fullExpr,
			boolean left) {
		if (!fullExpr.isOperation()) {
			return fullExpr.getEvaluateXPathString();
		}

		int myPrecedence = this.getPrecedence();
		int thePrecedence = fullExpr.getPrecedence();

		boolean needParens = true;
		if (myPrecedence < thePrecedence) {
			needParens = false;
		} else if (myPrecedence == thePrecedence) {
			if (isSymmetric()) {
				needParens = false;
			} else {
				needParens = !left;
			}
		}

		if (needParens) {
			return "(" + fullExpr.getEvaluateXPathString() + ")";
		} else {
			return fullExpr.getEvaluateXPathString();
		}
	}

	/** ******************************************************************************************* */
	/**
	 * given a setpXTT_Node and return a expression which is a parent of this
	 * step node
	 * 
	 * @param stepNode
	 *            a StepXTT_Node
	 * @return a ExpressionXTT_Node
	 */
	public ExpressionXTT_Node getExpression(StepXTT_Node stepNode) {
		XTT_Node parentNode = stepNode.getParent();
		while (!(parentNode instanceof ExpressionXTT_Node)) {
			parentNode = parentNode.getParent();
		}
		return (ExpressionXTT_Node) parentNode;
	}
//?
	public String getEvaluateXPathString(StepXTT_Node lastStep) {
		ExpressionXTT_Node targetExpr = getExpression(lastStep);
		Iterator iterator = this.expressions.iterator();
		String result = "";
		if (!isOperation()) {
			if (iterator.hasNext()) {
				XTT_Node thisNode = (XTT_Node) iterator.next();
				//find the target expression
				if (thisNode.getMySequenceNum() == targetExpr
						.getMySequenceNum()) {
					int lastStepNum = lastStep.getStepNum();
					result = ((ExpressionXTT_Node) thisNode)
							.getDebugEvalXPathString(lastStepNum);
				} else {
					result = thisNode.getEvaluateXPathString();
				}
			}
		} else {
			if (this.expressions.size() == 1) {
				result = getOperator().toString()
						+ parenthesizeEvalStr(
								(FullExpressionXTT_Node) expressions.get(0),
								false, lastStep);
			} else {
				StringBuffer buffer = new StringBuffer();
				for (int i = 0; i < expressions.size(); i++) {
					if (i > 0) {
						buffer.append(' ');
						buffer.append(getOperator().toString());
						buffer.append(' ');
					}
					buffer.append(parenthesizeEvalStr(
							(FullExpressionXTT_Node) expressions.get(i),
							i == 0, lastStep));
				}
				result = buffer.toString();
			}
		}
		return result;

	}

	private String parenthesizeEvalStr(FullExpressionXTT_Node fullExpr,
			boolean left, StepXTT_Node lastStep) {
		if (!fullExpr.isOperation()) {
			return fullExpr.getEvaluateXPathString(lastStep);
		}

		int myPrecedence = this.getPrecedence();
		int thePrecedence = fullExpr.getPrecedence();

		boolean needParens = true;
		if (myPrecedence < thePrecedence) {
			needParens = false;
		} else if (myPrecedence == thePrecedence) {
			if (isSymmetric()) {
				needParens = false;
			} else {
				needParens = !left;
			}
		}

		if (needParens) {
			return "(" + fullExpr.getEvaluateXPathString(lastStep) + ")";
		} else {
			return fullExpr.getEvaluateXPathString(lastStep);
		}
	}

	/** ******************************************************************************************** */
	/**
	 * @return Returns the precedence.
	 */
	public int getPrecedence() {
		return precedence;
	}

	/**
	 * @param precedence
	 *            The precedence to set.
	 */
	public void setPrecedence(int precedence) {
		this.precedence = precedence;
	}

	/**
	 * @return Returns the symmetric.
	 */
	public boolean isSymmetric() {
		return symmetric;
	}

	/**
	 * @param symmetric
	 *            The symmetric to set.
	 */
	public void setSymmetric(boolean symmetric) {
		this.symmetric = symmetric;
	}

	/**
	 * @param isOperation
	 *            The isOperation to set.
	 */
	public void setOperationType(int operationType) {
		this.operationType = operationType;

	}

	public boolean isOperation() {
		return this.operationType > 0;
	}

	/**
	 * 
	 * @return true if I am a root.
	 */
	public boolean isRoot() {
		if (getParent() == null) {
			return true;
		} else
			return false;
	}

	/*
	 * updated the context for this full DXPath expression.
	 */
	public void updateContextPath(String newContextPath) {
		if (newContextPath.endsWith("/")) {
			int len = newContextPath.length();
			newContextPath = newContextPath.substring(0, len - 1);
		}
		if (super.getContextPath() != newContextPath) {
			super.updateContextPath(newContextPath);
			Iterator iterator = this.expressions.iterator();
			while (iterator.hasNext()) {
				Object thisExpr = iterator.next();
				if (thisExpr instanceof XTT_Node) {
					((XTT_Node) thisExpr).updateContextPath(newContextPath);
				}
			}
		}

	}

	public QName getXPathResultType() {
		if (this.isOperation()) {
			if (this.operationType == OP_ADD | this.operationType == OP_DIVIDE
					| this.operationType == OP_MOD
					| this.operationType == OP_MULTIPLY
					| this.operationType == OP_NEGATE
					| this.operationType == OP_SUBTRACT) {
				return XPathConstants.NUMBER;
			} else if (this.operationType == OP_AND
					| this.operationType == OP_EQUAL
					| this.operationType == OP_NOT_EQUAL
					| this.operationType == OP_GREATER_THAN
					| this.operationType == OP_GREATER_THAN_EQUAL
					| this.operationType == OP_LESS_TAHN
					| this.operationType == OP_LESS_TAHN_EQUAL
					| this.operationType == OP_OR) {
				return XPathConstants.BOOLEAN;
			} else if (this.operationType == OP_UNION) {
				return XPathConstants.NODESET;
			}

		} else {
			 ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			 if(expr.getExpressionType()==ExpressionXTT_Node.CONSTANT_EXPRESSION){
			 	String xpathStr = expr.getXPathString();
			 	try {
					int n = Integer.parseInt(xpathStr);

					return XPathConstants.NUMBER;
					//if there is a exception, this token is not a int.
				} catch (NumberFormatException nfe) {
					//is it a double number?
					try {
						double dn = Double.parseDouble(xpathStr);
						return XPathConstants.NUMBER;
					} catch (NumberFormatException dnfe) {

						return XPathConstants.STRING;
					}
				}
			 }else if(expr.getExpressionType()==ExpressionXTT_Node.FUNCTION_EXPRESSION){
			 	FunctionXTT_Node functionNode = (FunctionXTT_Node)expr.getChildNode();
			 	return functionNode.getXPathResultType();
			 	
			 //this must be a path expression, the return type is nodeset.	
			 }else {
			 	return XPathConstants.NODESET;	
			 }
			
			
		}
		//should not reach here.
		return null;
	}
	/**
	 * 
	 * @return true if need context path for evaluating
	 */
	public boolean needContextPath(){
		if (this.isOperation()) {
			if (this.operationType == OP_UNION){
				Iterator iterator = this.expressions.iterator();
				while(iterator.hasNext()){
					FullExpressionXTT_Node expr = (FullExpressionXTT_Node)iterator.next();
					if(expr.needContextPath()){
						return true;
					}
				}
			}
		}else{
			ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			if(expr.getExpressionType()==ExpressionXTT_Node.FUNCTION_EXPRESSION){
				FunctionXTT_Node functionNode = (FunctionXTT_Node)expr.getChildNode();
				return functionNode.isNeedContextPath();
			}
		}
		return false;
		
	}
	
	public void backupColor(){
		if(this.isOperation()){
			Iterator iterator = this.expressions.iterator();
			while(iterator.hasNext()){
				FullExpressionXTT_Node expr = (FullExpressionXTT_Node)iterator.next();
                expr.backupColor();
			}
		}else{
			ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			if(expr.getExpressionType()==ExpressionXTT_Node.PATH_EXPRESSION){
				StepXTT_Node stepNode = (StepXTT_Node)expr.getChildNode();
				stepNode.backupColor();
			}
		}
	}
	
	public void updateColor(int colorIndex){
		if(this.isOperation()){
			Iterator iterator = this.expressions.iterator();
			while(iterator.hasNext()){
				FullExpressionXTT_Node expr = (FullExpressionXTT_Node)iterator.next();
                expr.updateColor(colorIndex);
			}
		}else{
			ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			if(expr.getExpressionType()==ExpressionXTT_Node.PATH_EXPRESSION){
				StepXTT_Node stepNode = (StepXTT_Node)expr.getChildNode();
				stepNode.updateColor(colorIndex);
			}
		}
	}
	
	/**
	 * get all step nodes that are contained in the expression that contains
	 * the given stepNode 
	 * @param stepNode a given StepDXPathNode
	 * @return a list of StepDXPathNode
	 */
	public  List getAllSteps(StepXTT_Node stepNode){
		List result = new ArrayList();
		ExpressionXTT_Node parentNode = getExpression(stepNode);
		XTT_Node firstStep = parentNode.getChildNode();
		StepXTT_Node childStep = null;
		if(firstStep instanceof StepXTT_Node){
			result.add(firstStep);
			childStep = ((StepXTT_Node)firstStep).getChildStep();
	    }
	    while(childStep !=null){
	    	result.add(childStep);
	    	childStep = childStep.getChildStep();
	    }
	    return result;
	}
	
	public List findMySteps(Node w3cNode){
		List mySteps = new ArrayList();
		
		if(this.isOperation()){
			Iterator iterator = this.expressions.iterator();
			while(iterator.hasNext()){
				FullExpressionXTT_Node expr = (FullExpressionXTT_Node)iterator.next();
                XTTHelper.listConcat(mySteps, expr.findMySteps(w3cNode));
			}
		}else{
			ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			if(expr.getExpressionType()==ExpressionXTT_Node.PATH_EXPRESSION){
				StepXTT_Node stepNode = (StepXTT_Node)expr.getChildNode();
				StepXTT_Node childNode = stepNode;
				XPathResult result;
				while (childNode != null) {
					result = childNode.getPathNodeResult();
					if (result != null
					    && result.getResultType() == XPathConstants.NODESET) {
						if (XTTHelper.containThisNode((NodeList)result.getResult(), w3cNode)) {
								mySteps.add(childNode);
						}
						
						
					}
					childNode = childNode.getChildStep();
				}
			}
		}
		return mySteps;
	}
	
	/**
	 * check if the given W3C Dom node is in this XPath Expression final result.
	 * @param node, a W3C DOM node
	 * @return
	 * @throws XPathException
	 */
	public boolean isFinialResult(Node w3cNode){
		if(this.xpathResult==null)
			return false;
		if(this.xpathResult.getResultType()!=XPathConstants.NODESET){
			return false;
		}else{
			return XTTHelper.containThisNode((NodeList)this.xpathResult.getResult(), w3cNode);
		}
	}
	
	public List getLastNavigatingNodes(){
		List finalNodes = new ArrayList();
		if(this.isOperation()){
			Iterator iterator = this.expressions.iterator();
			while(iterator.hasNext()){
				FullExpressionXTT_Node expr = (FullExpressionXTT_Node)iterator.next();
                XTTHelper.listConcat(finalNodes, expr.getLastNavigatingNodes());
			}
		}else{
			ExpressionXTT_Node expr = (ExpressionXTT_Node)this.expressions.get(0);
			if(expr.getExpressionType()==ExpressionXTT_Node.PATH_EXPRESSION){
				
				if(expr.getLastNavigatingNodes()!=null){
					finalNodes = XTTHelper.nodeListToList(expr.getLastNavigatingNodes());
				}
				
				
			}
		}
		return finalNodes;
		
		
	}
	
}